searchData={"items":[{"type":"task","title":"mix compile.nerves_flutter_support","doc":"Compiler module used to ensure that pre-compiled tools are properly installed at compile time","ref":"Mix.Tasks.Compile.NervesFlutterSupport.html"},{"type":"function","title":"Mix.Tasks.Compile.NervesFlutterSupport.run/1","doc":"","ref":"Mix.Tasks.Compile.NervesFlutterSupport.html#run/1"},{"type":"task","title":"mix flutter.build_aot","doc":"Builds a Flutter app using the version of Flutter shipped with `nerves_flutter_support`.\n\nUsage: `mix flutter.build_aot /path/to/flutter_app /output/bunlde/dir`","ref":"Mix.Tasks.Flutter.BuildAot.html"},{"type":"task","title":"mix flutter.install_tools","doc":"Installs runtime libs and tools for Flutter support on Nerves.","ref":"Mix.Tasks.Flutter.InstallTools.html"},{"type":"module","title":"NervesFlutterSupport.Application","doc":"Main application for Nerves Flutter Support.\nMostly just starts the eudev process, which is needed to properly handle input.","ref":"NervesFlutterSupport.Application.html"},{"type":"function","title":"NervesFlutterSupport.Application.start/2","doc":"","ref":"NervesFlutterSupport.Application.html#start/2"},{"type":"module","title":"NervesFlutterSupport.BuildFlutterApp","doc":"A Mix release module that can be included into a parent mix project.\nThis takes care of packing up all the flutter assets in a project.\nIt also aids in compiling them into an AOT application for optimal perf on the target.","ref":"NervesFlutterSupport.BuildFlutterApp.html"},{"type":"function","title":"NervesFlutterSupport.BuildFlutterApp.get_flutter_sdk_path/0","doc":"","ref":"NervesFlutterSupport.BuildFlutterApp.html#get_flutter_sdk_path/0"},{"type":"function","title":"NervesFlutterSupport.BuildFlutterApp.run/1","doc":"","ref":"NervesFlutterSupport.BuildFlutterApp.html#run/1"},{"type":"module","title":"NervesFlutterSupport.DownloadCache","doc":"A utility module to help cache and fetch cached data from a known cache namespace.","ref":"NervesFlutterSupport.DownloadCache.html"},{"type":"function","title":"NervesFlutterSupport.DownloadCache.clear_cache/0","doc":"Attempts to delete the download cache directory.","ref":"NervesFlutterSupport.DownloadCache.html#clear_cache/0"},{"type":"function","title":"NervesFlutterSupport.DownloadCache.fetch/1","doc":"Given a cache key (sha256 hash) this function attempts to find the matching data\nin the on-disk cache. If the file isn't found, returns `:miss`.\n\nIf the cache data is found, `{:hit, data}` is returned.\n\nOther error conditions will return an error tuple.","ref":"NervesFlutterSupport.DownloadCache.html#fetch/1"},{"type":"function","title":"NervesFlutterSupport.DownloadCache.put/2","doc":"Takes in a key (binary) and data (binary) and writes it to the cache on disk.\n\nCan return an error tuple if a write fails.","ref":"NervesFlutterSupport.DownloadCache.html#put/2"},{"type":"module","title":"NervesFlutterSupport.Downloader","doc":"Module that contains functions to download files from the `nerves_flutter_support` CDN and Girhub.","ref":"NervesFlutterSupport.Downloader.html"},{"type":"function","title":"NervesFlutterSupport.Downloader.create_host_utils_url/0","doc":"Computes and returns the URL to the host utilities archive that matches\nthis release of `nerves_flutter_support`.\n\nIn general this is tied to the `FLUTTER_ENGINE_HASH` value in the package.","ref":"NervesFlutterSupport.Downloader.html#create_host_utils_url/0"},{"type":"function","title":"NervesFlutterSupport.Downloader.create_runtime_url/0","doc":"Computes and returns the URL to the runtime artifact archive that matches\nthis release of `nerves_flutter_support`.\n\nIn general this is tied to the `FLUTTER_ENGINE_HASH` value in the package.","ref":"NervesFlutterSupport.Downloader.html#create_runtime_url/0"},{"type":"function","title":"NervesFlutterSupport.Downloader.download_host_tools/0","doc":"Downloads the Flutter Linux Embedded host tools archive for this version of `nerves_flutter_support`.","ref":"NervesFlutterSupport.Downloader.html#download_host_tools/0"},{"type":"function","title":"NervesFlutterSupport.Downloader.download_runtime_artifacts/0","doc":"Downloads the Flutter Linux Embedded runtime artifact archive for this version of `nerves_flutter_support`.","ref":"NervesFlutterSupport.Downloader.html#download_runtime_artifacts/0"},{"type":"function","title":"NervesFlutterSupport.Downloader.get_flutter_hash/0","doc":"Gets the Flutter engine hash from the `FLUTTER_ENGINE_HASH` file.\n\nThis is used to compute the URL to download pre-build artifacts.","ref":"NervesFlutterSupport.Downloader.html#get_flutter_hash/0"},{"type":"module","title":"NervesFlutterSupport.Flutter.Engine","doc":"Module to create Flutter's runtime child","ref":"NervesFlutterSupport.Flutter.Engine.html"},{"type":"function","title":"NervesFlutterSupport.Flutter.Engine.create_child/1","doc":"Ensures existing running Flutter engines are killed.\nReturns a `child_spec()` that can be supervised, which starts the flutter app\n\nArguments:\n  `:app_name` - This should be the atom name of the application that contains the Flutter app.\n                It's expected that the compiled AOT Flutter bundle will be found at `priv/flutter_app`.\n\n  `:env` - A map of additions environment variables to set when launching the Flutter engine.\n          `%{binary() => binary()}`\n\n  `:args` - A list of strings of extra command line arguments to pass to the Flutter embedder.\n\n  `:bundle_path` - A string that's a path to an AOT Flutter bundle. This will override the computed\n                   path from `:app_name`.","ref":"NervesFlutterSupport.Flutter.Engine.html#create_child/1"},{"type":"function","title":"NervesFlutterSupport.Flutter.Engine.kill/0","doc":"Kills all currently running instances of the flutter engine","ref":"NervesFlutterSupport.Flutter.Engine.html#kill/0"},{"type":"module","title":"NervesFlutterSupport.InstallRuntime","doc":"A Mix release step that copies the runtime artifacts from `NervesFlutterSupport`'s `priv` directory\ninto the properly location in the release `_build` directory. This is required, because sometimes `mix`\nwill not re-copy artifacts if they were not present at the initial `mix deps.get` command.\n\nSince we install runtime artifacts afterwords, this step ensures they wind up in the final release bundle.","ref":"NervesFlutterSupport.InstallRuntime.html"},{"type":"function","title":"NervesFlutterSupport.InstallRuntime.run/1","doc":"","ref":"NervesFlutterSupport.InstallRuntime.html#run/1"},{"type":"module","title":"NervesFlutterSupport.ToolInstaller","doc":"This module contains functions to manage downloading, installing and removing of runtimes and tools.\n\nNervesFlutterSupport requires a few different host utilities, and runtime artifacts. This module ensures\nthey are all properly installed and in the correct locations before attempting to build firmware.\n\nGenerally you will not need to call these functions directly.","ref":"NervesFlutterSupport.ToolInstaller.html"},{"type":"function","title":"NervesFlutterSupport.ToolInstaller.ensure_host_tools_installed/0","doc":"","ref":"NervesFlutterSupport.ToolInstaller.html#ensure_host_tools_installed/0"},{"type":"function","title":"NervesFlutterSupport.ToolInstaller.ensure_runtime_installed/0","doc":"","ref":"NervesFlutterSupport.ToolInstaller.html#ensure_runtime_installed/0"},{"type":"function","title":"NervesFlutterSupport.ToolInstaller.perform_checks/0","doc":"","ref":"NervesFlutterSupport.ToolInstaller.html#perform_checks/0"},{"type":"module","title":"NervesFlutterSupport.Udev","doc":"The Flutter engine requires that udev is running to register input devices.\nThis module provides utility functions to start `eudev` (a more minimal udev) and register devices.\nIt also provides a number of utility methods to fetch the current DRI cards, and get info about them.","ref":"NervesFlutterSupport.Udev.html"},{"type":"function","title":"NervesFlutterSupport.Udev.create_child/1","doc":"Returns a `child_spec()` that monitors the eudev daemon","ref":"NervesFlutterSupport.Udev.html#create_child/1"},{"type":"function","title":"NervesFlutterSupport.Udev.get_card_info/1","doc":"Returns a list of tuples that contain information about the specified DRI card name","ref":"NervesFlutterSupport.Udev.html#get_card_info/1"},{"type":"function","title":"NervesFlutterSupport.Udev.get_cards/0","doc":"Returns a list of named devices under `/dev/dri`","ref":"NervesFlutterSupport.Udev.html#get_cards/0"},{"type":"function","title":"NervesFlutterSupport.Udev.is_output_card?/1","doc":"On some devices like the Raspberry Pi, `/dev/dri/card0` and  `/dev/dri/card1` are not deterministically named.\nGenerally one of the cards will only be the 3D accelerator, while the other is actually the display card.\n\nThis function will return `true` if the passed in card name is a output card (can actually draw to a display.)","ref":"NervesFlutterSupport.Udev.html#is_output_card?/1"},{"type":"function","title":"NervesFlutterSupport.Udev.setup/0","doc":"Reloads and triggers udev rules using `udevadm`","ref":"NervesFlutterSupport.Udev.html#setup/0"},{"type":"module","title":"NervesFlutterSupport.Util","doc":"Utility functions used in various internal parts of this package.\nYou probably do not need to use any of these.","ref":"NervesFlutterSupport.Util.html"},{"type":"function","title":"NervesFlutterSupport.Util.host_tools_installed?/0","doc":"","ref":"NervesFlutterSupport.Util.html#host_tools_installed?/0"},{"type":"function","title":"NervesFlutterSupport.Util.runtime_artifacts_installed?/0","doc":"","ref":"NervesFlutterSupport.Util.html#runtime_artifacts_installed?/0"},{"type":"function","title":"NervesFlutterSupport.Util.self_path/0","doc":"Returns the directory in which the package `nerves_flutter_support` is installed to.\n\nThis is only ever used at compile time. Otherwise the return value makes no sense.","ref":"NervesFlutterSupport.Util.html#self_path/0"},{"type":"extras","title":"nerves_flutter_support","doc":"# nerves_flutter_support\n\n![Static Badge](https://img.shields.io/badge/Flutter%20Version-v3.27.2-cyan?style=plastic&labelColor=black&color=blue)\n\n> ⚠️ NOTE: This is a fairly new project. Functionally everything is working on _tested_ Nerves systems.","ref":"readme.html"},{"type":"extras","title":"What Is This? - nerves_flutter_support","doc":"NervesFlutterSupport is the base library for running Flutter based UI applications on Nerves devices.","ref":"readme.html#what-is-this"},{"type":"extras","title":"Overview - nerves_flutter_support","doc":"NervesFlutterSupport contains the following components:\n\n* Pre-compiled and patched runtime libraries for various dependencies. (See `builder/` for more info.)\n  * Including a pre-compiled version of Sony's open source [Flutter Embedder](https://github.com/sony/flutter-embedded-linux).\n* A pair of [Mix Release Steps](https://hexdocs.pm/mix/1.18.2/Mix.Tasks.Release.html#module-steps) that can be included in your existing Mix project.\n  * Takes care of downloading the Flutter [embedder](https://github.com/sony/flutter-embedded-linux) and runtime libraries.\n  * Will automatically compile your Flutter project using the `gen_snapshot` tool and output an AOT build.\n  * Will help copy the runtime artifacts from the dependency source directory to the release directory at compile time.\n* `NervesFlutterSupport.Flutter.Engine` - A module to create a [Muontrap](https://hexdocs.pm/muontrap/readme.html) child_spec for running the embedder.\n* `NervesFlutterSupport.Udev` - (Automatically started for you) A module that ensure `eudevd` is running for input devices to function properly.","ref":"readme.html#overview"},{"type":"extras","title":"Tested Platforms - nerves_flutter_support","doc":"NervesFlutterSupport has been tested on the following platforms:\n\n* Raspberry Pi 4\n* Raspberry Pi 5\n\nHowever it should be noted that any aarch64 based Nerves System _should be compatible_ with this library.\n\nPlease file any issues if you run into any problems with your ARM64 platform. We also welcome Buildroot config contributions for other platforms.","ref":"readme.html#tested-platforms"},{"type":"extras","title":"Getting Started - nerves_flutter_support","doc":"**Currently we only support Linux and macOS hosts when building firmware. Windows users should use WSL.**\n\n**If you are a macOS user, please ensure you have `docker` installed!**\n\n1. Install [Flutter](https://docs.flutter.dev/get-started/install). See the top of this readme file for which version to use. (Flutter versions may change with Hex package versions!)\n2. Create a new Flutter app in your Mix project using: `flutter create flutter_app`.\n3. Add this package to your `deps` in `mix.exs`.\n4. Add the release steps to your existing firmware's `steps:`:\n  ```elixir\n    steps: [\n      &Nerves.Release.init/1,\n      &NervesFlutterSupport.InstallRuntime.run/1, # REQUIRED!! - Add this to install runtime artifacts into the release!\n      &NervesFlutterSupport.BuildFlutterApp.run/1, # OPTIONAL - Add this if you want to auto-compile a flutter app!\n      :assemble\n    ],\n  ```\n5. Run `mix firmware` as you normally would, if all is well, you should see you Flutter app build and emit a bundle into your `priv/` directory.\n6. To run the Flutter app you can add the following to your `Application` or `Supervisor` children:\n  ```elixir\n  # With no options, your Flutter app bundle is expreted to be in `priv/flutter_app`\n  NervesFlutterSupport.Flutter.Engine.create_child(\n    app_name: :my_flutter_app,\n  )\n  ```","ref":"readme.html#getting-started"},{"type":"extras","title":"Example Project - nerves_flutter_support","doc":"Example Project: [NervesFlutterExample](https://github.com/nerves-flutter/nerves_flutter_example)\n\n`NervesFlutterExample` is a basic Flutter + Nerves firmware for `:rpi4` and `:rpi5` targets. It uses\ngRPC and Protobufs to communicate between the Nerves firmware code and the Dart Flutter application.","ref":"readme.html#example-project"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}